!function(){"use strict";try{if("undefined"!=typeof document){var t=document.createElement("style");t.appendChild(document.createTextNode(".text_contaner[data-v-d70aa132]{display:inline-block}.binds_text_item[data-v-d70aa132]{display:inline-block;clip-path:inset(0 100% 0 0);opacity:0}.binds_animation[data-v-d70aa132]{animation-name:binds-d70aa132;animation-timing-function:linear;animation-fill-mode:forwards}@keyframes binds-d70aa132{0%{clip-path:inset(0 100% 0 0);opacity:0}to{clip-path:inset(0 0 0 0);opacity:1}}.text_contaner[data-v-447dce10]{display:inline-block}.inclined_animation[data-v-447dce10]{animation-timing-function:linear;animation-fill-mode:forwards}.right_top[data-v-447dce10]{animation-name:right_top-447dce10}.right_bottom[data-v-447dce10]{animation-name:right_bottom-447dce10}.left_top[data-v-447dce10]{animation-name:left_top-447dce10}.left_bottom[data-v-447dce10]{animation-name:left_bottom-447dce10}@keyframes right_top-447dce10{0%{clip-path:polygon(100% 0,100% 0,100% 0,100% 0,100% 0)}50%{clip-path:polygon(0 0,0 0,100% 0,100% 100%,100% 100%)}to{clip-path:polygon(0 100%,0 0,100% 0,100% 100%,0 100%)}}@keyframes right_bottom-447dce10{0%{clip-path:polygon(100% 100%,100% 100%,100% 100%,100% 100%,100% 100%)}50%{clip-path:polygon(100% 0,100% 0,100% 100%,0 100%,0 100%)}to{clip-path:polygon(0 0,100% 0,100% 100%,0 100%,0 0)}}@keyframes left_top-447dce10{0%{clip-path:polygon(0 0,0 0,0 0,0 0,0 0)}50%{clip-path:polygon(0 100%,0 100%,0 0,100% 0,100% 0)}to{clip-path:polygon(100% 100%,0 100%,0 0,100% 0,100% 100%)}}@keyframes left_bottom-447dce10{0%{clip-path:polygon(0 100%,0 100%,0 100%,0 100%,0 100%)}50%{clip-path:polygon(0 0,0 0,0 100%,100% 100%,100% 100%)}to{clip-path:polygon(100% 0,0 0,0 100%,100% 100%,100% 0)}}")),document.head.appendChild(t)}}catch(a){console.error("vite-plugin-css-injected-by-js",a)}}();
import { ref, computed, nextTick, defineComponent, openBlock, createElementBlock, Fragment, renderList, unref, normalizeClass, normalizeStyle, toDisplayString, createElementVNode, renderSlot } from "vue";
function debounce(func, wait = 200) {
  let timeout = null;
  return function(...args) {
    clearTimeout(timeout);
    timeout = setTimeout(() => {
      func.apply(this, args);
    }, wait);
  };
}
function CommonFn() {
  let animationState = ref("paused");
  let isAnimation = ref(true);
  const start = () => {
    animationState.value = "running";
  };
  const paused = () => {
    animationState.value = "paused";
  };
  const rest = (dealy = 200) => {
    paused();
    isAnimation.value = false;
    setTimeout(() => {
      nextTick(() => {
        isAnimation.value = true;
        start();
      });
    }, dealy);
  };
  return {
    isAnimation,
    animationState,
    start,
    paused,
    rest
  };
}
function getTextArr(props) {
  let texts = computed(() => {
    let current = props.text;
    if (current) {
      return current.split("");
    }
    return [];
  });
  return { texts };
}
const _hoisted_1 = { class: "text_contaner" };
const _sfc_main$1 = /* @__PURE__ */ defineComponent({
  ...{
    name: "Binds"
  },
  __name: "index",
  props: {
    text: {
      type: String,
      default: ""
    },
    immediately: {
      type: Boolean,
      default: true
    },
    duration: {
      type: [String, Number],
      default: 0.5
    }
  },
  emits: ["onStart", "onEnd"],
  setup(__props, { expose: __expose, emit: __emit }) {
    const props = __props;
    const {
      isAnimation,
      animationState,
      start,
      paused,
      rest
    } = CommonFn();
    const { texts } = getTextArr(props);
    const emits = __emit;
    const animationStart = debounce(() => {
      emits("onStart");
    });
    const animationEnd = debounce(() => {
      emits("onEnd");
    });
    if (props.immediately) {
      start();
    } else {
      paused();
    }
    __expose({ start, paused, rest });
    return (_ctx, _cache) => {
      return openBlock(), createElementBlock("div", _hoisted_1, [
        (openBlock(true), createElementBlock(Fragment, null, renderList(unref(texts), (item, index) => {
          return openBlock(), createElementBlock("span", {
            class: normalizeClass(["binds_text_item", unref(isAnimation) ? "binds_animation" : ""]),
            key: index,
            style: normalizeStyle({
              animationDelay: `${Math.random() * 0.5}s`,
              animationPlayState: unref(animationState),
              animationDuration: `${__props.duration}s`
            }),
            "on:webkitAnimationStart": _cache[0] || (_cache[0] = //@ts-ignore
            (...args) => unref(animationStart) && unref(animationStart)(...args)),
            onAnimationstart: _cache[1] || (_cache[1] = //@ts-ignore
            (...args) => unref(animationStart) && unref(animationStart)(...args)),
            "on:webkitAnimationEnd": _cache[2] || (_cache[2] = //@ts-ignore
            (...args) => unref(animationEnd) && unref(animationEnd)(...args)),
            "on:animationEnd": _cache[3] || (_cache[3] = //@ts-ignore
            (...args) => unref(animationEnd) && unref(animationEnd)(...args))
          }, toDisplayString(item), 39);
        }), 128)),
        createElementVNode("div", {
          class: normalizeClass(["binds_text_item", unref(isAnimation) ? "binds_animation" : ""]),
          style: normalizeStyle({
            animationDelay: `${Math.random() * 0.5}s`,
            animationPlayState: unref(animationState),
            animationDuration: `${__props.duration}s`
          })
        }, [
          renderSlot(_ctx.$slots, "default", {}, void 0, true)
        ], 6)
      ]);
    };
  }
});
const _export_sfc = (sfc, props) => {
  const target = sfc.__vccOpts || sfc;
  for (const [key, val] of props) {
    target[key] = val;
  }
  return target;
};
const Binds = /* @__PURE__ */ _export_sfc(_sfc_main$1, [["__scopeId", "data-v-d70aa132"]]);
Binds.install = (app) => {
  app.component(Binds.name, Binds);
};
const _sfc_main = /* @__PURE__ */ defineComponent({
  ...{
    name: "Inclined"
  },
  __name: "index",
  props: {
    immediately: {
      type: Boolean,
      default: true
    },
    duration: {
      type: [String, Number],
      default: 0.5
    },
    delay: {
      type: [String, Number],
      default: 0
    },
    direction: {
      type: String,
      default: "left_top"
    }
  },
  emits: ["onStart", "onEnd"],
  setup(__props, { expose: __expose, emit: __emit }) {
    const props = __props;
    const {
      isAnimation,
      animationState,
      start,
      paused,
      rest
    } = CommonFn();
    const emits = __emit;
    const animationStart = debounce(() => {
      emits("onStart");
    });
    const animationEnd = debounce(() => {
      emits("onEnd");
    });
    if (props.immediately) {
      start();
    } else {
      paused();
    }
    __expose({ start, paused, rest });
    return (_ctx, _cache) => {
      return openBlock(), createElementBlock("div", {
        class: normalizeClass(["text_contaner inclined_animation", [unref(isAnimation) ? __props.direction : ""]]),
        style: normalizeStyle({
          animationDelay: `${__props.delay}s`,
          animationPlayState: unref(animationState),
          animationDuration: `${__props.duration}s`
        }),
        "on:webkitAnimationStart": _cache[0] || (_cache[0] = //@ts-ignore
        (...args) => unref(animationStart) && unref(animationStart)(...args)),
        onAnimationstart: _cache[1] || (_cache[1] = //@ts-ignore
        (...args) => unref(animationStart) && unref(animationStart)(...args)),
        "on:webkitAnimationEnd": _cache[2] || (_cache[2] = //@ts-ignore
        (...args) => unref(animationEnd) && unref(animationEnd)(...args)),
        "on:animationEnd": _cache[3] || (_cache[3] = //@ts-ignore
        (...args) => unref(animationEnd) && unref(animationEnd)(...args))
      }, [
        renderSlot(_ctx.$slots, "default", {}, void 0, true)
      ], 38);
    };
  }
});
const Inclined = /* @__PURE__ */ _export_sfc(_sfc_main, [["__scopeId", "data-v-447dce10"]]);
Inclined.install = (app) => {
  app.component(Inclined.name, Inclined);
};
const components = [
  Binds,
  Inclined
];
const install = (app) => {
  components.forEach((component) => app.component(component.name, component));
};
const vue = window.Vue;
if (typeof window !== "undefined" && vue) {
  install(vue);
}
const Vue3TextAnimations = {
  install
};
export {
  Binds,
  Inclined,
  Vue3TextAnimations as default
};
